import 'package:flutter/material.dart';
import 'package:rubber/rubber.dart';


class RubberConcierge extends StatefulWidget {
  final RubberAnimationController controller;
  final Widget opener, closer;

  const RubberConcierge({Key key,
    @required this.controller,
    this.opener: const Icon(Icons.arrow_upward),
    this.closer: const Icon(Icons.arrow_downward),
  }) : assert(controller != null),
        assert(opener != null), assert(closer != null), super(key: key);

  @override
  _RubberConciergeState createState() => _RubberConciergeState();
}

class _RubberConciergeState extends State<RubberConcierge> {
  RubberAnimationController _controller;
  bool isOpen = false;

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    _controller?.removeListener(_listener);
    _controller = widget.controller;
    _controller.addListener(_listener);
  }

  dispose() {
    _controller.removeListener(_listener);
    super.dispose();
  }

  _listener() {
    setState(() {
      isOpen = _controller.value == 1;
    });
  }

  @override
  Widget build(BuildContext context) {
    return IconButton(
      onPressed: () {
        isOpen ? _controller.collapse() : _controller.expand();
      },
      icon: isOpen ? widget.closer : widget.opener,
    );
  }
}